/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "pokerui.h"

void pokerUiInit(pokergame_t *pokerGame) {
  uint8_t i, j;

  j = 0;
  for(i = 0; i < POKER_PLAYER_COUNT; i++) {
    if(i == POKER_PLAYER_HUMAN_INDEX) continue;
    pokerPlayerUiInit(pokerGame->ui.player + j);
    j++;
  }
}

void pokerUiUpdate(pokergame_t *pokerGame, engine_t *engine) {
  uint8_t i, j;
  pokerplayerui_t *ui;

  j = 0;
  for(i = 0; i < POKER_PLAYER_COUNT; i++) {
    if(i == POKER_PLAYER_HUMAN_INDEX) continue;
    ui = pokerGame->ui.player + j;
    pokerPlayerUiUpdate(ui, pokerGame, &pokerGame->assets.shader, i, engine);
    j++;
  }
}

void pokerUiRender(pokergame_t *pokerGame, engine_t *engine) {
  uint8_t i, j;
  pokerplayerui_t *ui;

  j = 0;
  for(i = 0; i < POKER_PLAYER_COUNT; i++) {
    if(i == POKER_PLAYER_HUMAN_INDEX) continue;
    ui = pokerGame->ui.player + j;

    pokerPlayerUiRender(ui, pokerGame,
      &pokerGame->assets.shader, &pokerGame->assets.font, i,
      engine->render.width, j * 75.0f
    );
    j++;
  }
}

void pokerUiDispose(pokergame_t *pokerGame) {
  uint8_t i, j;

  j = 0;
  for(i = 0; i < POKER_PLAYER_COUNT; i++) {
    if(i == POKER_PLAYER_HUMAN_INDEX) continue;
    pokerPlayerUiDispose(pokerGame->ui.player + j);
    j++;
  }
}